'
' channel.exe passes channel change requests to WinLIRC via its network interface.
'
' Usage: channel [channel number]
'   Running channel without parameters starts the configuration program.
' 
' Original source code from http://computersmithery.com/Channel.aspx
' Logging and network timeouts added by Puckdropper, http://puckdroppersplace.us/computer/
'
' Brett Smith wrote the original source code, and has graciously permitted me to post it as well as the new code for Logging and network timeouts.
'

Option Strict On
Option Explicit On

Public Class frmMain

    Private MyProcess As Process
    Private RetryAfterFailure As Boolean
    Private FailureTimeout As Decimal

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Me.Visible = True Then
            Dim mboxSave As Microsoft.VisualBasic.MsgBoxResult = MsgBox("Save Before Closing", MsgBoxStyle.YesNoCancel, Me.Text)
            Select Case mboxSave
                Case MsgBoxResult.Yes
                    My.Settings.Save()
                Case MsgBoxResult.Cancel
                    e.Cancel = True
            End Select
        End If
    End Sub

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MyProcess = Process.GetCurrentProcess

        Dim strArgs() As String = Environment.GetCommandLineArgs()

        If strArgs.Length > 1 Then
            Me.Hide()
            Dim intChannel As Integer
            WinLIRC.strRemote = My.Settings.Remote
            WinLIRC.intRepeat = CInt(My.Settings.Repeat)
            WinLIRC.intPadding = CInt(My.Settings.Padding)
            WinLIRC.strConfirmCMD = My.Settings.ConfirmCMD
            WinLIRC.intWaitTime = CInt(My.Settings.WaitTime)
            WinLIRC.strServerIP = My.Settings.LIRCServerIP
            WinLIRC.intServerPort = CInt(My.Settings.LIRCServerPort)
            WinLIRC.Log = My.Settings.Log
            WinLIRC.TIMEOUT = CInt(My.Settings.Timeout)
            RetryAfterFailure = My.Settings.RetryAfterFailure
            FailureTimeout = My.Settings.FailureTimeout

            Try
                Dim Success As Boolean
                'change the channel
                intChannel = CInt(strArgs(1))
                MyProcess.PriorityClass = ProcessPriorityClass.RealTime
                Success = ChangeChannelNew(intChannel)
                If (Success = False And RetryAfterFailure = True) Then
                    Write("Failure changing channel.  Retrying once.")
                    ' The Dish network receiver waits for 5 seconds before giving up, so we need to wait longer.
                    System.Threading.Thread.Sleep(CInt(FailureTimeout))
                    ChangeChannelNew(intChannel)
                End If
            Catch ex As Exception
                MsgBox("Command syntax:" & vbCrLf & _
                    "channel.exe (Channel)" & vbCrLf & vbCrLf & _
                    "Channel: REQUIRED the channel number to change to" & vbCrLf & _
                    "Example: channel.exe 100", MsgBoxStyle.Exclamation, Me.Text)
            End Try

            'close the hidden form
            Me.Close()
        Else
            'output the console to the richtextbox
            Console.SetOut(New ConsoleWriter(Me.rtxtOutput))
        End If
    End Sub

    Private Sub btnTest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTest.Click
        Dim intChannel As Integer
        WinLIRC.strRemote = Me.txtRemote.Text
        WinLIRC.intRepeat = CInt(Me.numRepeat.Value)
        WinLIRC.intPadding = CInt(Me.numPadding.Value)
        WinLIRC.strConfirmCMD = Me.txtConfirm.Text
        WinLIRC.intWaitTime = CInt(Me.numWait.Value)
        WinLIRC.strServerIP = Me.txtServerIP.Text
        WinLIRC.intServerPort = CInt(Me.numServerPort.Value)
        WinLIRC.Log = CheckBoxLogging.Checked
        WinLIRC.TIMEOUT = CInt(Me.numTimeout.Value)
        RetryAfterFailure = My.Settings.RetryAfterFailure
        FailureTimeout = My.Settings.FailureTimeout

        Try
            Me.rtxtOutput.Text = ""
            'change the channel
            intChannel = CInt(Me.numChannel.Value)
            MyProcess.PriorityClass = ProcessPriorityClass.RealTime
            Dim Success As Boolean
            Success = ChangeChannelNew(intChannel)
            If (Success = False And RetryAfterFailure = True) Then
                Write("Failure changing channel.  Retrying once.")
                System.Threading.Thread.Sleep(500)
                ChangeChannelNew(intChannel)
            End If
        Catch ex As Exception
            MsgBox(ex.Message.ToString)
        End Try

    End Sub
End Class
